<?php 

/**
 * @wordpress-plugin
 * Plugin Name:       woodmart instagram widget
 * Plugin URI:         http://parvanja.ir
 * Description:       پلاگین ویدجت اینستا
 * Version:           3.0.0
 * Author:             مهدی محبی
 * Author URI:         http://parvanja.ir
 * License:           GPL-2.0+
 * License URI:        
 * Text Domain:       woodi_widget
 * Domain Path:       /languages
 */


/**
* WordPress Widgets Helper Class
*
* https://github.com/sksmatt/WordPress-Widgets-Helper-Class
*
* By @sksmatt | www.mattvarone.com
*
* @package      WordPress
* @subpackage   WPH Widget Class
* @author       Matt Varone
* @license      GPLv2
* @version      1.6
*/

/**
function woodi_insta_widget() {
  load_plugin_textdomain( 'woodi_widget', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}

add_action( 'init', 'woodi_insta_widget' );
*/
function plugin_name_load_plugin_textdomain() {
	$domain = 'woodi_widget';
	$locale = apply_filters( 'plugin_locale', get_locale(), $domain );
	// wp-content/languages/plugin-name/plugin-name-de_DE.mo
	load_textdomain( $domain, trailingslashit( WP_LANG_DIR ) . $domain . '/' . $domain . '-' . $locale . '.mo' );
	// wp-content/plugins/plugin-name/languages/plugin-name-de_DE.mo
	load_plugin_textdomain( $domain, FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'init', 'plugin_name_load_plugin_textdomain' );




function woodmart_instagram_widget_enqueue_script() {   
	wp_enqueue_script( 'woodmart_instagram_widget_js', plugin_dir_url( __FILE__ ) . 'js/functions.js', array('jquery'), '1.0' );
}
add_action('wp_enqueue_scripts', 'woodmart_instagram_widget_enqueue_script');
//add_action('admin_enqueue_scripts', 'woodmart_instagram_widget_enqueue_script');


function woodmart_instagram_widget_enqueue_style() {
        wp_enqueue_style( 'woodmart_instagram_widget_css1', plugin_dir_url( __FILE__ ) . 'css/base.css', false, '1.0.0' );
		wp_enqueue_style( 'woodmart_instagram_widget_css2', plugin_dir_url( __FILE__ ) . 'css/base-rtl.css', false, '1.0.0' );
		wp_enqueue_style( 'woodmart_instagram_widget_css3', plugin_dir_url( __FILE__ ) . 'css/style.css', false, '1.0.0' );
		wp_enqueue_style( 'woodmart_instagram_widget_css4', plugin_dir_url( __FILE__ ) . 'css/style-rtl.css', false, '1.0.0' );
}

add_action( 'wp_enqueue_scripts', 'woodmart_instagram_widget_enqueue_style' ); 








if ( ! class_exists( 'WPH_Widget' ) ) 
{

    class WPH_Widget extends WP_Widget
    {

        /** 
        * Create Widget 
        * 
        * Creates a new widget and sets it's labels, description, fields and options 
        * 
        * @access   public
        * @param    array
        * @return   void
        * @since    1.0
        */

        function create_widget( $args ) {
            // settings some defaults
            $defaults = array( 
                'label'        => '', 
                'description'  => '', 
                'fields'       => array(), 
                'options'      => array(),
                'slug'    => '', 
             );

            // parse and merge args with defaults
            $args = wp_parse_args( $args, $defaults );

            // extract each arg to its own variable
            extract( $args, EXTR_SKIP );            

            // set the widget vars
            $this->slug    = ( $slug ) ? $slug : sanitize_title( $label );
            $this->fields  = $fields;

            // check options
            $this->options = array( 'classname' => $this->slug, 'description' => $description );                        
            if ( ! empty( $options ) ) $this->options = array_merge( $this->options, $options );

            // call WP_Widget to create the widget
            parent::__construct( $this->slug, $label, $this->options );

        }


        /** 
        * Form
        * 
        * Creates the settings form. 
        * 
        * @access   private
        * @param    array
        * @return   void
        * @since    1.0     
        */

        function form( $instance ) {
            $this->instance = $instance;
            echo $this->create_fields(); //Dynamic data escaped while generating the variable.
        }


        /** 
        * Update Fields
        *  
        * @access   private
        * @param    array
        * @param    array
        * @return   array
        * @since    1.0
        */

        function update( $new_instance, $old_instance ) {
            $instance = $old_instance;

            
            $this->before_update_fields();

            foreach ( $this->fields as $key ) {
                $slug = (isset($key['id'])) ? $key['id'] : $key['param_name'];

                if ( isset( $key['validate'] ) ) {
                    if ( false === $this->validate( $key['validate'], $new_instance[$slug] ) )
                    return $instance;
                }

                if ( isset( $key['filter'] ) )
                    $instance[$slug] = $this->filter( $key['filter'], $new_instance[$slug] );
                else
                    $instance[$slug] = strip_tags( $new_instance[$slug] );
            }
            
            return $this->after_validate_fields( $instance );
        }
        
        
        /** 
        * Before Validate Fields
        *
        * Allows to hook code on the update.
        *  
        * @access   public
        * @param    string
        * @return   string
        * @since    1.6
        */

        function before_update_fields() {
            return;
        }


        /** 
        * After Validate Fields
        * 
        * Allows to modify the output after validating the fields.
        *
        * @access   public
        * @param    string
        * @return   string
        * @since    1.6
        */

        function after_validate_fields( $instance = "" ) {
            return $instance;
        }
        
        
        /** 
        * Validate 
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   boolean
        * @since    1.0
        */

        function validate( $rules, $value ) {
            $rules = explode( '|', $rules );

            if ( empty( $rules ) || count( $rules ) < 1 )
                return true;

            foreach ( $rules as $rule ) {
                if ( false === $this->do_validation( $rule, $value ) )
                return false;
            }

            return true;
        }


        /** 
        * Filter 
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   void
        * @since    1.0
        */

        function filter( $filters, $value ) {
            $filters = explode( '|', $filters ); 

            if ( empty( $filters ) || count( $filters ) < 1 )
                return $value;

            foreach ( $filters as $filter ) 
                $value = $this->do_filter( $filter, $value );

            return $value;
        }


        /** 
        * Do Validation Rule
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   boolean
        * @since    1.0
        */

        function do_validation( $rule, $value = "" )
        {
            switch ( $rule ) {

                case 'alpha':
                    return ctype_alpha( $value );
                break;

                case 'alpha_numeric':
                    return ctype_alnum( $value );
                break;

                case 'alpha_dash':
                    return preg_match( '/^[a-z0-9-_]+$/', $value );
                break;

                case 'numeric':
                    return ctype_digit( $value );
                break;

                case 'integer':
                    return ( bool ) preg_match( '/^[\-+]?[0-9]+$/', $value );
                break;

                case 'boolean':
                    return is_bool( $value );
                break;

                case 'email':
                    return is_email( $value );
                break;

                case 'decimal':
                    return ( bool ) preg_match( '/^[\-+]?[0-9]+\.[0-9]+$/', $value );
                break;

                case 'natural':
                    return ( bool ) preg_match( '/^[0-9]+$/', $value );
                return;

                case 'natural_not_zero':
                    if ( ! preg_match( '/^[0-9]+$/', $value ) ) return false;
                    if ( $value == 0 ) return false;
                    return true;
                return;

                default:
                    if ( method_exists( $this, $rule ) )
                        return $this->$rule( $value );
                    else
                        return false;
                break;

            }
        }       


        /** 
        * Do Filter
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   boolean
        * @since    1.0
        */

        function do_filter( $filter, $value = "" )
        {
            switch ( $filter ) 
            {
                case 'strip_tags':
                    return strip_tags( $value );
                break;

                case 'wp_strip_all_tags':
                    return wp_strip_all_tags( $value );
                break;

                case 'esc_attr':
                    return esc_attr( $value );
                break;

                case 'esc_url':
                    return esc_url( $value );
                break;

                case 'esc_textarea':
                    return esc_textarea( $value );
                break;

                default:
                    if ( method_exists( $this, $filter ) )
                        return $this->$filter( $value );
                    else
                        return $value;
                break;
            }
        }


        /** 
        * Create Fields 
        * 
        * Creates each field defined. 
        * 
        * @access   private
        * @param    string
        * @return   string
        * @since    1.0
        */

        function create_fields( $out = "" ) {

            $out = $this->before_create_fields( $out );

            if ( ! empty( $this->fields ) ) {
                foreach ( $this->fields as $key ) {
                    if ( empty( $key ) ) continue;
                    $out .= $this->create_field( $key );
                }
            }

            $out = $this->after_create_fields( $out );

            return $out;
        }


        /** 
        * Before Create Fields
        *
        * Allows to modify code before creating the fields.
        *  
        * @access   public
        * @param    string
        * @return   string
        * @since    1.0
        */

        function before_create_fields( $out = "" ) {
            return $out;
        }


        /** 
        * After Create Fields
        * 
        * Allows to modify code after creating the fields.
        *
        * @access   public
        * @param    string
        * @return   string
        * @since    1.0
        */

        function after_create_fields( $out = "" ) {
            return $out;
        }


        /** 
        * Create Fields
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   string
        * @since    1.0
        */

        function create_field( $key, $out = "" ) {

            /* Set Defaults */
            $key['std'] = isset( $key['std'] ) ? $key['std'] : "";
            $key['std'] = isset( $key['default'] ) ? $key['default'] : "";

            $slug = (isset($key['id'])) ? $key['id'] : $key['param_name'];
            $heading = isset( $key['heading'] ) ? $key['heading'] : '';
            $key['name'] = (isset($key['name'])) ? $key['name'] : $heading;

            if(isset($key['skip_in']) && $key['skip_in'] == 'widget') {
                return;
            }
            if(isset($key['value'])) {
                $key['fields'] = $key['value'];
            }

            if ( isset( $key['true_state'] ) && isset( $key['false_state'] ) ) {
                $key['fields'] = array(
                    $key['true_state'] => $key['true_state'],
                    $key['false_state'] => $key['false_state'],
                );
            }
                  
            if(!isset($key['class'])) {
                $key['class'] = 'widefat';
            }
                  
            if(isset($key['description'])) {
                $key['desc'] = $key['description'];
            }

            if ( isset( $this->instance[$slug] ) )
                $key['value'] = empty( $this->instance[$slug] ) ? '' : strip_tags( $this->instance[$slug] );
            else
                unset( $key['value'] );

            /* Set field id and name  */
            $key['_id'] = $this->get_field_id( $slug );
            $key['_name'] = $this->get_field_name( $slug );

            /* Set field type */
            if ( ! isset( $key['type'] ) ) $key['type'] = 'text';

            $key['type'] = $this->woodmart_change_type($key['type']);

            /* Prefix method */
            $field_method = 'create_field_' . str_replace( '-', '_', $key['type'] );

            /* Check for <p> Class */
            $p = ( isset( $key['class-p'] ) ) ? '<p class="'.$key['class-p'].'">' : '<p>'; 

            /* Run method */
            if ( method_exists( $this, $field_method ) ) 
                return $p.$this->$field_method( $key ).'</p>';

        }

        private function woodmart_change_type($key) {
            switch ($key) {
                case 'textfield':
                    $key = 'text';
                break;
                case 'vc_link':
                    $key = 'text';
                break;
                case 'href':
                    $key = 'text';
                break;
                case 'attach_images':
                    $key = 'attach_image';
                break;
                case 'textarea_html':
                    $key = 'textarea';
                break;
                case 'woodmart_switch':
                    $key = 'dropdown';
                break;
                case 'woodmart_button_set':
                    $key = 'dropdown';
                break;
                case 'woodmart_slider':
                    $key = 'dropdown';
                break;
                case 'woodmart_image_select':
                    $key = 'dropdown';
                break;
            }
            return $key;
        }


        /** 
        * dropdown field
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_dropdown( $key, $out = "" )
        {
			$out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $selected = isset( $key['value'] ) ? $key['value'] : $key['std'];

            $out .= '<select id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" data-value="' . esc_attr( $selected ) . '" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $out .= '> ';

                foreach ( $key['fields'] as $field => $option ) 
                {

                    $out .= '<option value="' . esc_attr( $option ) . '" ';

                    if ( esc_attr( $selected ) == $option )
                        $out .= ' selected="selected" ';

                    $out .= '> '.esc_html( $field ).'</option>';

                }

            $out .= ' </select> ';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;            
        }

        /** 
        * attach image field
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_attach_image( $key, $out = "" )
        {

            $value = isset( $key['value'] ) ? $key['value'] : $key['std'];

            $url = $style = '';

            if(isset($value)) {
                $url = wp_get_attachment_url($value);
            }

            if($url == '') {
                $style = 'display:none;';
            }

            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<img src="'.$url.'" class="woodmart-image-src" style="'.$style.'" />';

            $out .= '<input type="hidden" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="woodmart-image-upload ' . esc_attr( $key['class'] ) . '" ';


            $out .= 'id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" value="' . esc_attr( $value ) . '" ';

            if ( isset( $key['size'] ) )
                $out .= 'size="' . esc_attr( $key['size'] ) . '" ';             

            $out .= ' />';

            $out .= '<button class="button woodmart-image-upload-btn">' .__('Upload image', 'woodmart') . '</button>';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;
        }


        /** 
        * Field Text
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_text( $key, $out = "" )
        {
            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<input type="text" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $value = isset( $key['value'] ) ? $key['value'] : $key['std'];

            $out .= 'id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" value="' . esc_attr( $value ) . '" ';

            if ( isset( $key['size'] ) )
                $out .= 'size="' . esc_attr( $key['size'] ) . '" ';             

            $out .= ' />';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;
        }


        /** 
        * Field Textarea
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_textarea( $key, $out = "" )
        {
            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<textarea ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            if ( isset( $key['rows'] ) )
                $out .= 'rows="' . esc_attr( $key['rows'] ) . '" '; 

            if ( isset( $key['cols'] ) )
                $out .= 'cols="' . esc_attr( $key['cols'] ) . '" '; 

            $value = isset( $key['value'] ) ? $key['value'] : $key['std'];

            $out .= 'id="'. esc_attr( $key['_id'] ) .'" name="' . esc_attr( $key['_name'] ) . '">'.esc_html( $value );

            $out .= '</textarea>';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;
        }

 
        /** 
        * Field Checkbox
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_checkbox( $key, $out = "" )
        {
            $out .= $this->create_field_label( $key['name'], $key['_id'] );

            $out .= ' <input type="checkbox" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $out .= 'id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" value="1" ';
            
            if ( ( isset( $key['value'] ) && $key['value'] == 1 ) OR ( ! isset( $key['value'] ) && $key['std'] == 1 ) )
                $out .= ' checked="checked" ';          

            $out .= ' /> ';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;            
        }


        /** 
        * Field Select
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_select( $key, $out = "" )
        {
            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<select id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $out .= '> ';

            $selected = isset( $key['value'] ) ? $key['value'] : $key['std'];

                foreach ( $key['fields'] as $field => $option ) 
                {

                    $out .= '<option value="' . esc_attr( $option['value'] ) . '" ';

                    if ( esc_attr( $selected ) == $option['value'] )
                        $out .= ' selected="selected" ';

                    $out .= '> '.esc_html( $option['name'] ).'</option>';

                }

            $out .= ' </select> ';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;            
        }


        /** 
        * Field Select with Options Group
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */    
          
        function create_field_select_group( $key, $out = "" )
        {

            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<select id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $out .= '> ';

            $selected = isset( $key['value'] ) ? $key['value'] : $key['std'];

                foreach ( $key['fields'] as $group => $fields ) 
                {

                    $out .= '<optgroup label="' . $group . '">';

                    foreach ( $fields as $field => $option ) 
                    {
                        $out .= '<option value="' . esc_attr( $option['value'] ) . '" ';

                        if ( esc_attr( $selected ) == $option['value'] )
                            $out .= ' selected="selected" ';

                        $out .= '> ' . esc_html( $option['name'] ) . '</option>';
                    }

                    $out .= '</optgroup>';

                }

            $out .= '</select>';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;            
        }
        
        
        /** 
        * Field Number
        *  
        * @access   private
        * @param    array
        * @param    string
        * @return   string
        * @since    1.5
        */
        
        function create_field_number( $key, $out = "" )
        {
            $out .= $this->create_field_label( $key['name'], $key['_id'] ) . '<br/>';

            $out .= '<input type="number" ';

            if ( isset( $key['class'] ) )
                $out .= 'class="' . esc_attr( $key['class'] ) . '" ';

            $value = isset( $key['value'] ) ? $key['value'] : $key['std'];

            $out .= 'id="' . esc_attr( $key['_id'] ) . '" name="' . esc_attr( $key['_name'] ) . '" value="' . esc_attr( $value ) . '" ';

            if ( isset( $key['size'] ) )
                $out .= 'size="' . esc_attr( $key['size'] ) . '" ';             

            $out .= ' />';
            
            if ( isset( $key['desc'] ) )
                $out .= '<br/><small class="description">'.esc_html( $key['desc'] ).'</small>';

            return $out;
        }


        /** 
        * Field Label
        *  
        * @access   private
        * @param    string
        * @param    string
        * @return   string
        * @since    1.5
        */

        function create_field_label( $name = "", $id = "" ) {
            return '<label for="' . esc_attr( $id ). '">' . esc_html( $name ) . ':</label>';
        }

    } // class
}




















/**
* ------------------------------------------------------------------------------------------------
* Instagram element map
* ------------------------------------------------------------------------------------------------
*/

if( ! function_exists( 'woodmart_vc_map_instagram' ) ) {
	function woodmart_vc_map_instagram() {
		if ( ! shortcode_exists( 'woodmart_instagram' ) ) {
			return;
		}

		vc_map( array(
			'name' => esc_html__( 'Instagram', 'woodi_widget' ),
			'base' => 'woodmart_instagram',
			'category' => esc_html__( 'Theme elements', 'woodi_widget' ),
			'description' => esc_html__( 'Instagram photos', 'woodi_widget' ),
        	'icon' => WOODMART_ASSETS . '/images/vc-icon/instagram.svg',
			'params' =>  woodmart_get_instagram_params()
		) );
	}
	add_action( 'vc_before_init', 'woodmart_vc_map_instagram' );
}

if( ! function_exists( 'woodmart_get_instagram_params' ) ) {
	function woodmart_get_instagram_params() {
		return apply_filters( 'woodmart_get_instagram_params', array(
			/**
			* Content
			*/
			array(
				'type' => 'woodmart_title_divider',
				'holder' => 'div',
				'title' => esc_html__( 'Content', 'woodi_widget' ),
				'param_name' => 'content_divider'
			),
			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Title', 'woodi_widget' ),
				'param_name' => 'title',
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Username', 'woodi_widget' ),
				'hint' => esc_html__( 'Enter your Instagram username. For example: asos', 'woodi_widget' ),
				'param_name' => 'username',
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_slider',
				'heading' => esc_html__( 'Number of photos', 'woodi_widget' ),
				'param_name' => 'number',
				'value' => array( 
					'9' => '9',
					'12' => '12',
					'11' => '11',
					'10' => '10',
					'8' => '8',
					'7' => '7',
					'6' => '6',
					'5' => '5',
					'4' => '4',
					'3' => '3',
					'2' => '2',
					'1' => '1',
				),
				'min' => '1',
				'max' => '12',
				'step' => '1',
				'default' => '9',
				'units' => '',
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_button_set',
				'heading' => esc_html__( 'Photo size', 'woodi_widget' ),
				'param_name' => 'size',
				'value' => array(
					esc_html__( 'Thumbnail', 'woodi_widget' ) => 'thumbnail',
					esc_html__( 'Large', 'woodi_widget' ) => 'large'
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'textarea_html',
				'holder' => 'div',
				'heading' => esc_html__( 'Instagram text', 'woodi_widget' ),
				'param_name' => 'content',
				'skip_in' => 'widget',
				'hint' => esc_html__( 'Add here few words about your instagram profile.', 'woodi_widget' )
			),
			/**
			* Link
			*/
			array(
				'type' => 'woodmart_title_divider',
				'holder' => 'div',
				'title' => esc_html__( 'Link', 'woodi_widget' ),
				'param_name' => 'link_divider'
			),
			array(
				'type' => 'dropdown',
				'heading' => esc_html__( 'Open link in', 'woodi_widget' ),
				'param_name' => 'target',
				'value' => array(
					esc_html__( 'Current window (_self)', 'woodi_widget' ) => '_self',
					esc_html__( 'New window (_blank)', 'woodi_widget' ) => '_blank'
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Link text', 'woodi_widget' ),
				'param_name' => 'link',
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			/**
			* Layout
			*/
			array(
				'type' => 'woodmart_title_divider',
				'holder' => 'div',
				'title' => esc_html__( 'Layout', 'woodi_widget' ),
				'param_name' => 'layout_divider'
			),
			array(
				'type' => 'woodmart_button_set',
				'heading' => esc_html__( 'Layout', 'woodi_widget' ),
				'param_name' => 'design',
				'skip_in' => 'widget',
				'value' => array(
					esc_html__( 'Grid', 'woodi_widget' ) => 'grid',
					esc_html__( 'Slider', 'woodi_widget' ) => 'slider'
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_slider',
				'heading' => esc_html__( 'Photos per row', 'woodi_widget' ),
				'param_name' => 'per_row',
				'skip_in' => 'widget',
				'min' => '1',
				'max' => '12',
				'step' => '1',
				'default' => '3',
				'units' => '',
				'edit_field_class' => 'vc_col-sm-6 vc_column',
				'hint' => esc_html__( 'Number of photos per row for grid design or items in slider per view.', 'woodi_widget' )
			),
			array(
				'type' => 'woodmart_switch',
				'heading' => esc_html__( 'Add spaces between photos', 'woodi_widget' ),
				'skip_in' => 'widget',
				'param_name' => 'spacing',
				'true_state' => 1,
				'false_state' => 0,
				'default' => 0,
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'dropdown',
				'heading' => esc_html__( 'Space between images', 'woodi_widget' ),
				'param_name' => 'spacing_custom',
				'skip_in' => 'widget',
				'value' => array(
					'', 0, 2, 6, 10, 20, 30
				),
				'dependency' => array(
					'element' => 'spacing',
					'value' => array( '1' ),
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_switch',
				'heading' => esc_html__( 'Rounded corners for images', 'woodi_widget' ),
				'skip_in' => 'widget',
				'param_name' => 'rounded',
				'true_state' => 1,
				'false_state' => 0,
				'default' => 0,
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_switch',
				'heading' => esc_html__( 'Hide likes and comments', 'woodi_widget' ),
				'skip_in' => 'widget',
				'param_name' => 'hide_mask',
				'true_state' => 1,
				'false_state' => 0,
				'default' => 0,
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_switch',
				'heading' => esc_html__( 'Hide pagination control', 'woodi_widget' ),
				'param_name' => 'hide_pagination_control',
				'hint' => esc_html__( 'If "YES" pagination control will be removed', 'woodi_widget' ),
				'true_state' => 'yes',
				'false_state' => 'no',
				'default' => 'no',
				'skip_in' => 'widget',
				'dependency' => array(
					'element' => 'design',
					'value' => array( 'slider' )
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			array(
				'type' => 'woodmart_switch',
				'heading' => esc_html__( 'Hide prev/next buttons', 'woodi_widget' ),
				'param_name' => 'hide_prev_next_buttons',
				'hint' => esc_html__( 'If "YES" prev/next control will be removed', 'woodi_widget' ),
				'true_state' => 'yes',
				'false_state' => 'no',
				'default' => 'no',
				'skip_in' => 'widget',
				'dependency' => array(
					'element' => 'design',
					'value' => array( 'slider' )
				),
				'edit_field_class' => 'vc_col-sm-6 vc_column',
			),
			/**
			* Extra
			*/
			array(
				'type' => 'woodmart_title_divider',
				'holder' => 'div',
				'title' => esc_html__( 'Extra options', 'woodi_widget' ),
				'param_name' => 'extra_divider'
			),
			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Extra class name', 'woodi_widget' ),
				'skip_in' => 'widget',
				'param_name' => 'el_class',
				'hint' => esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'woodi_widget' )
			),
		) );
	}
}




/**
 * Register widget based on VC_MAP parameters that display isntagram widget
 *
 */

if ( ! class_exists( 'WOODMART_Instagram_Widget' ) ) {
	class WOODMART_Instagram_Widget extends WPH_Widget {
	
		function __construct() {
			if( ! function_exists( 'woodmart_get_instagram_params' ) ) return;
		
			// Configure widget array
			$args = array( 
				// Widget Backend label
				'label' => esc_html__( 'WOODMART Instagram', 'woodi_widget' ), 
				// Widget Backend Description								
				'description' => esc_html__( 'Instagram photos', 'woodi_widget' ), 		
				'slug' => 'woodmart-instagram',
			 );
		
			// Configure the widget fields
		
			// fields array
			$args['fields'] = woodmart_get_instagram_params();

			// create widget
			$this->create_widget( $args );
		}
		
		// Output function

		function widget( $args, $instance )	{

			extract($args);

			echo wp_kses_post( $before_widget );

			if(!empty($instance['title'])) { echo wp_kses_post( $before_title ). $instance['title'] . wp_kses_post( $after_title ); };

			do_action( 'wpiw_before_widget', $instance );

			$instance['title'] = '';
			$instance['spacing'] = 1;
			$instance['spacing_custom'] = 6;
			$instance['per_row'] = 3;

			echo woodmart_shortcode_instagram( $instance );

			do_action( 'wpiw_after_widget', $instance );

			echo wp_kses_post( $after_widget );
		}
	
	} // class
}


function myplugin_register_widgets() {
	register_widget( 'WOODMART_Instagram_Widget' );
}

add_action( 'widgets_init', 'myplugin_register_widgets' );























/**
* ------------------------------------------------------------------------------------------------
* Instagram shortcode
* ------------------------------------------------------------------------------------------------
*/

if( ! function_exists( 'woodmart_shortcode_instagram' ) ) {
	function woodmart_shortcode_instagram( $atts, $content = '' ) {
		$output = $pics_classes = $picture_classes = $owl_atts = '';
		$parsed_atts = shortcode_atts( array(
			'title' => '',
			'username' => 'flickr',
			'number' => 9,
			'size' => 'medium',
			'target' => '_self',
			'link' => '',
			'design' => 'grid',
			'spacing' => 0,
			'spacing_custom' => 6,
			'rounded' => 0,
			'per_row' => 3,
			'hide_mask' => 0,
			'hide_pagination_control' => '',
			'hide_prev_next_buttons' => '',
			'el_class' => '',
			'ajax_body' => false,
			'content' => $content,
		), $atts );

		extract( $parsed_atts );

		$carousel_id = 'carousel-' . rand(100,999);

		ob_start();

		$class = 'instagram-widget';

		$class .= $el_class ? ' ' . $el_class : '';

		if( $design != '' ) {
			$class .= ' instagram-' . $design;
		}

		if( $rounded == 1 ) {
			$class .= ' instagram-rounded';
		}

		if ( ! $spacing ) {
			$spacing_custom = 0;
		}

		if ( $design == 'slider' ) {
			$custom_sizes = apply_filters( 'woodmart_instagram_shortcode_custom_sizes', false );

			$owl_atts = woodmart_get_owl_attributes( array(
				'carousel_id' => $carousel_id,
				'hide_pagination_control' => $hide_pagination_control,
				'hide_prev_next_buttons' => $hide_prev_next_buttons,
				'slides_per_view' => $per_row,
				'custom_sizes' => $custom_sizes,
			) );

			if ( woodmart_get_opt( 'disable_owl_mobile_devices' ) ) {
				$class .= ' disable-owl-mobile';
			}

			$pics_classes .= ' owl-carousel ' . woodmart_owl_items_per_slide( $per_row, array(), false, false, $custom_sizes );
			$class .= ' woodmart-carousel-container';
			$class .= ' woodmart-carousel-spacing-' . $spacing_custom;
		} else {
			$pics_classes .= ' row';
			$picture_classes .= woodmart_get_grid_el_class( 0, $per_row );
			$pics_classes .= ' woodmart-spacing-' . $spacing_custom;
		}

		$media_array = woodmart_scrape_instagram($username, $number, $ajax_body);

		unset($parsed_atts['ajax_body']);

		$encoded_atts = json_encode( $parsed_atts );

		if ( is_wp_error( $media_array ) && $media_array->get_error_code() === 'invalid_response_429' ) {
			$class .= ' instagram-with-error';
			$media_array = array();
			$hide_mask = true;
			for ($i=0; $i < $number; $i++) { 
				$media_array[] = array(
					$size => WOODMART_ASSETS . '/images/settings/instagram/insta-placeholder.jpg',
					'link' => '#',
					'likes' => '0',
					'comments' => '0',
				);
			}
		}

		echo '<div id="' . esc_attr( $carousel_id ) . '" data-atts="' . esc_attr( $encoded_atts ) . '" data-username="' . esc_attr( $username ) . '" class="instagram-pics ' . esc_attr( $class ) . '" ' . $owl_atts . '>';

		if(!empty($title)) { echo '<h3 class="title">' . $title . '</h3>'; };

		if ($username != '' && !is_wp_error( $media_array )) {
			if ( ! empty( $content ) ): ?>
				<div class="instagram-content">
					<div class="instagram-content-inner">
						<?php echo do_shortcode( $content ); ?>
					</div>
				</div>
			<?php endif;

			?>
				<div class="<?php echo esc_attr( $pics_classes ); ?>">
				<?php foreach ( $media_array as $item ) : ?>
					<?php $image = (! empty( $item[$size] )) ? $item[$size] : $item['thumbnail']; ?>
				
					<div class="instagram-picture<?php echo esc_attr( $picture_classes ); ?>">
						<div class="wrapp-picture">
							<a href="<?php echo esc_url( $item['link'] ); ?>" target="<?php echo esc_attr( $target ); ?>"></a>
							<?php echo apply_filters('woodmart_image', '<img src="'. esc_url( $image ) .'" />' ); ?>
							<?php if ( $hide_mask == 0 ) : ?>
								<div class="hover-mask">
									<span class="instagram-likes"><span><?php echo esc_attr( woodmart_pretty_number( $item['likes'] ) ); ?></span></span>
									<span class="instagram-comments"><span><?php echo esc_attr( woodmart_pretty_number( $item['comments'] ) ); ?></span></span>
								</div>
							<?php endif; ?>
						</div>
					</div>
				<?php endforeach; ?>
				</div>
			<?php
		} else {
			echo esc_html( $media_array->get_error_message() );
		}

		if ($link != '') {
			?><p class="clear"><a href="//instagram.com/<?php echo trim($username); ?>" rel="me" target="<?php echo esc_attr( $target ); ?>"><?php echo esc_html($link); ?></a></p><?php
		}

		echo '</div>';

		$output = ob_get_contents();
		ob_end_clean();

		return $output;

	}
}

if( ! function_exists( 'woodmart_pretty_number' ) ) {
	function woodmart_pretty_number( $x = 0 ) {
		$x = (int) $x;

		if( $x > 1000000 ) {
			return floor( $x / 1000000 ) . 'M';
		}

		if( $x > 10000 ) {
			return floor( $x / 1000 ) . 'k';
		}
		return $x;
	}
}

if( ! function_exists( 'woodmart_scrape_instagram' ) ) {
	function woodmart_scrape_instagram( $username, $slice = 9, $ajax_body = false ) {
		$username = strtolower( $username );
		
		$by_hashtag = ( substr( $username, 0, 1 ) == '#' );
		$transient_name = 'instagram-media-new-' . sanitize_title_with_dashes( $username );
		$instagram = get_transient( $transient_name );
		
		if ( 1) {//if ( false === $instagram ) {
			
			if ( 1 ) {//if ( ! $ajax_body ) {
				$request_param = ( $by_hashtag ) ? 'explore/tags/' . substr( $username, 1 ) : trim( $username );
				$remote = wp_remote_get( 'https://www.instagram.com/'. $request_param . '/' );
				
				if ( is_wp_error( $remote ) ) {
					return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Instagram.', 'woodi_widget' ) );
					
				}

				if ( 200 != wp_remote_retrieve_response_code( $remote ) ) {
					return new WP_Error( 'invalid_response_' . wp_remote_retrieve_response_code( $remote ), esc_html__( 'Instagram did not return a 200.', 'woodi_widget' ) );
				}

				$shards = explode( 'window._sharedData = ', $remote['body'] );
			} else {
				$remote = stripslashes( $ajax_body );
				$shards = explode( 'window._sharedData = ', $remote );
			}

			$insta_json = explode( ';</script>', $shards[1] );
			$insta_array = json_decode( $insta_json[0], TRUE );

			if ( ! $insta_array ){
				return new WP_Error( 'bad_json', esc_html__( 'Instagram has returned invalid data.', 'woodi_widget' ) );
			}
				
			if ( isset( $insta_array['entry_data']['ProfilePage'][0]['graphql']['user']['edge_owner_to_timeline_media']['edges'] ) ) {
				
				$images = $insta_array['entry_data']['ProfilePage'][0]['graphql']['user']['edge_owner_to_timeline_media']['edges'];
			} elseif( $by_hashtag && isset( $insta_array['entry_data']['TagPage'][0]['graphql']['hashtag']['edge_hashtag_to_media']['edges'] ) ) {
		        $images = $insta_array['entry_data']['TagPage'][0]['graphql']['hashtag']['edge_hashtag_to_media']['edges'];
		    } else {
				return new WP_Error( 'bad_json_2', esc_html__( 'Instagram has returned invalid data.', 'woodi_widget' ) );
			}

			if ( ! is_array( $images ) ) {
				return new WP_Error( 'bad_array', esc_html__( 'Instagram has returned invalid data.', 'woodi_widget' ) );
			}
			
				
			$instagram = array();
			
			foreach ( $images as $image ) {
				
				$image = $image['node'];
				$caption = esc_html__( 'Instagram Image', 'woodi_widget' );
				if ( ! empty( $image['edge_media_to_caption']['edges'][0]['node']['text'] ) ) $caption = $image['edge_media_to_caption']['edges'][0]['node']['text'];

				$image['thumbnail_src'] = preg_replace( "/^https:/i", "", $image['thumbnail_src'] );
				$image['thumbnail'] = preg_replace( "/^https:/i", "", $image['thumbnail_resources'][0]['src'] );
				$image['medium'] = preg_replace( "/^https:/i", "", $image['thumbnail_resources'][2]['src'] );
				$image['large'] = $image['thumbnail_src'];
				
				$type = ( $image['is_video'] ) ? 'video' : 'image';
				
				$instagram[] = array(
					'description'   => $caption,
					'link'		  	=> '//instagram.com/p/' . $image['shortcode'],
					'comments'	  	=> $image['edge_media_to_comment']['count'],
					'likes'		 	=> $image['edge_liked_by']['count'],
					'thumbnail'	 	=> $image['thumbnail'],
					'medium'		=> $image['medium'],
					'large'			=> $image['large'],
					'type'		  	=> $type
				);
			}
		
			// do not set an empty transient - should help catch private or empty accounts
			//if ( ! empty( $instagram ) ) {
			//	$instagram = function_exists( 'woodmart_compress' ) ? woodmart_compress( maybe_serialize( $instagram ) ) : '';
			//	set_transient( $transient_name, $instagram, apply_filters( 'null_instagram_cache_time', HOUR_IN_SECONDS * 2 ) );
			//}
		}
		if ( ! empty( $instagram ) ) {
			//$instagram = function_exists( 'woodmart_decompress' ) ? maybe_unserialize( woodmart_decompress( $instagram ) ) : array();
			return array_slice( $instagram, 0, $slice );
		} else {
			return new WP_Error( 'no_images', esc_html__( 'Instagram did not return any images22.', 'woodi_widget' ) );
		}
	}
}

if( !function_exists( 'woodmart_instagram_images_only' ) ) {
	function woodmart_instagram_images_only($media_item) {
		if ($media_item['type'] == 'image')
			return true;

		return false;
	}
}


if ( ! function_exists( 'woodmart_instagram_ajax_query' ) ) {
	function woodmart_instagram_ajax_query(){
		if ( ! empty( $_POST['atts'] ) && ! empty( $_POST['body'] ) ) {
			$atts = woodmart_clean( $_POST['atts'] );

			$atts['ajax_body'] = trim( $_POST['body'] );
			$data = woodmart_shortcode_instagram( $atts );
			echo json_encode( $data );
			die();
		}
	}

	add_action( 'wp_ajax_woodmart_instagram_ajax_query', 'woodmart_instagram_ajax_query' );
	add_action( 'wp_ajax_nopriv_woodmart_instagram_ajax_query', 'woodmart_instagram_ajax_query' );
}



// **********************************************************************//
// Woodmart Get Settings JS
// **********************************************************************//
if ( ! function_exists('woodmart_settings_js') ) {
	function woodmart_settings_js() {

        $custom_js          = woodmart_get_opt( 'custom_js' );
        $js_ready           = woodmart_get_opt( 'js_ready' );

		ob_start();

        if( ! empty( $custom_js ) || ! empty( $js_ready ) ): ?>
            <?php if( ! empty( $custom_js ) ): ?>
                <?php echo woodmart_get_opt( 'custom_js' ); ?>
            <?php endif; ?>
            <?php if( ! empty( $js_ready ) ): ?>
                jQuery(document).ready(function() {
                    <?php echo woodmart_get_opt( 'js_ready' ); ?>
                });
            <?php endif; ?>
        <?php endif;

        return ob_get_clean();
	}
}








/**
 * ------------------------------------------------------------------------------------------------
 * Function to prepare classes for grid element (column)
 * ------------------------------------------------------------------------------------------------
 */

if ( ! function_exists( 'woodmart_get_grid_el_class' ) ) {
	function woodmart_get_grid_el_class( $loop = 0, $columns = 4, $different_sizes = false, $xs_size = false, $sm_size = 4, $lg_size = 3, $md_size = false ) {
		$classes = '';

		$items_wide = woodmart_get_wide_items_array( $different_sizes );

		if ( ! $xs_size ) {
			$xs_size = apply_filters( 'woodmart_grid_xs_default', 6 );
		}

		$lg_size = 12 / $columns;

		if ( ! $md_size ) {
			$md_size = $lg_size;
		}

		if ( $columns > 4 ) {
			$md_size = 3;
		}

		if ( $columns <= 3 ) {
			if ( $columns == 1 ) {
				$sm_size = 12;
				$xs_size = 12;
			} else {
				$sm_size = 6;
			}
		}		

		// every third element make 2 times larger (for isotope grid)
		if ( $different_sizes && ( in_array( $loop, $items_wide ) ) ) { 
			$lg_size *= 2;
			$md_size *= 2;
		}

		if ( in_array( $columns, array( 5, 7, 8, 9, 10, 11 ) ) ) {
            $lg_size = str_replace( '.', '_', round( 100 / $columns, 1 ) );
            if ( ! strpos( $lg_size, '_' ) ) {
                $lg_size = $lg_size . '_0';
            }
        }

		$classes .= ' col-' . $xs_size . ' col-sm-' . $sm_size . ' col-md-' . $md_size . ' col-lg-' . $lg_size;

		if ( $loop > 0 ) {
			if ( 0 == ( $loop - 1 ) % $columns || 1 == $columns ) {
				$classes .= ' first ';
			}
			if ( 0 == $loop % $columns ) {
				$classes .= ' last ';
			}
		}

		return $classes;
	}
}


if ( ! function_exists( 'woodmart_get_wide_items_array' ) ) {
	function woodmart_get_wide_items_array( $different_sizes = false ){
		$items_wide = apply_filters( 'woodmart_wide_items', array( 5, 6, 7, 8, 13, 14 ) );

		if( is_array( $different_sizes ) ) {
			$items_wide = apply_filters( 'woodmart_wide_items', $different_sizes );
		}

		return $items_wide;
	}
}
